from pathlib import PureWindowsPath

from agentpluginapi import (
    DropperExecutionMode,
    IWindowsAgentCommandBuilder,
    WindowsRunOptions,
    WindowsShell,
)


def build_powershell_command(
    agent_destination_path: PureWindowsPath,
    agent_command_builder: IWindowsAgentCommandBuilder,
):
    run_options = WindowsRunOptions(
        agent_destination_path=agent_destination_path,
        shell=WindowsShell.CMD,
        dropper_execution_mode=DropperExecutionMode.DROPPER,
    )
    agent_command_builder.build_run_command(run_options)
    return f"cmd.exe /c {agent_command_builder.get_command()}"
