from monkeytypes import InfectionMonkeyBaseModel
from pydantic import Field


class PowerShellOptions(InfectionMonkeyBaseModel):
    winrm_connect_timeout: float = Field(
        default=3.0,
        gt=0.0,
        le=100.0,
        title="WinRM Connection Timeout",
        description="The maximum time (in seconds) to wait for a response on a WinRM connection.",
    )
