from pathlib import PurePath
from typing import Any, Callable

from agentpluginapi import TargetHost
from plugintoolbox import IRemoteAccessClientFactory

from .powershell_client import PowerShellClient
from .powershell_options import PowerShellOptions
from .powershell_remote_access_client import PowerShellRemoteAccessClient


class PowerShellRemoteAccessClientFactory(IRemoteAccessClientFactory):
    def __init__(
        self,
        host: TargetHost,
        options: PowerShellOptions,
        command_builder: Callable[[PurePath], str],
    ):
        self._host = host
        self._options = options
        self._command_builder = command_builder

    def create(self, **kwargs: Any) -> PowerShellRemoteAccessClient:
        return PowerShellRemoteAccessClient(
            self._host, self._options, self._command_builder, PowerShellClient()
        )
