from pathlib import PureWindowsPath

from agentpluginapi import (
    DropperExecutionMode,
    IWindowsAgentCommandBuilder,
    WindowsRunOptions,
    WindowsShell,
)


def build_rdp_command(
    agent_destination_path: PureWindowsPath,
    agent_command_builder: IWindowsAgentCommandBuilder,
):
    run_options = WindowsRunOptions(
        dropper_execution_mode=DropperExecutionMode.DROPPER,
        agent_destination_path=agent_destination_path,
        shell=WindowsShell.CMD,
    )

    agent_command_builder.build_run_command(run_options)
    return agent_command_builder.get_command()
