from monkeytypes import InfectionMonkeyBaseModel
from pydantic import Field


class SNMPOptions(InfectionMonkeyBaseModel):
    agent_binary_download_timeout: float = Field(
        gt=0.0,
        default=60.0,
        title="Agent Binary Download Timeout",
        description="The maximum time (in seconds) to wait for a successfully exploited"
        " SNMP client to download the agent binary.",
    )
    snmp_request_timeout: float = Field(
        gt=0.0,
        default=0.5,
        title="SNMP Request Timeout",
        description="The maximum time (in seconds) to wait for a response from an SNMP client.",
    )
    snmp_retries: int = Field(
        ge=0,
        default=3,
        title="SNMP Retries",
        description="The number of times to retry an SNMP request before giving up.",
    )
