from monkeytypes import InfectionMonkeyBaseModel
from pydantic import Field


class SSHOptions(InfectionMonkeyBaseModel):
    connect_timeout: float = Field(
        default=15.0,
        gt=0.0,
        le=100.0,
        title="SSH Connection Timeout",
        description="The maximum time (in seconds) to wait to establish an SSH connection.",
    )
