from pathlib import PureWindowsPath

from agentpluginapi import (
    DropperExecutionMode,
    IWindowsAgentCommandBuilder,
    WindowsRunOptions,
    WindowsShell,
)


def build_wmi_command(
    remote_agent_binary_full_path: PureWindowsPath,
    remote_agent_binary_destination_path: PureWindowsPath,
    agent_command_builder: IWindowsAgentCommandBuilder,
) -> str:
    if remote_agent_binary_full_path == remote_agent_binary_destination_path:
        dropper_destination_path = None
        dropper_execution_mode = DropperExecutionMode.NONE
    else:
        dropper_destination_path = remote_agent_binary_destination_path
        dropper_execution_mode = DropperExecutionMode.DROPPER

    run_options = WindowsRunOptions(
        dropper_execution_mode=dropper_execution_mode,
        agent_destination_path=remote_agent_binary_full_path,
        shell=WindowsShell.CMD,
        dropper_destination_path=dropper_destination_path,
    )

    agent_command_builder.build_run_command(run_options)
    return f"cmd.exe /c {agent_command_builder.get_command()}"
