from monkeytypes import InfectionMonkeyBaseModel
from pydantic import Field


class ZerologonOptions(InfectionMonkeyBaseModel):
    max_attempts: int = Field(
        default=2000,
        ge=1,
        le=5000,
        title="Maximum Authentication Attempts",
        description="The maximum number of authentication attempts to make. "
        "It takes 256 attempts, on average, to successfully authenticate.",
    )
